package com.sillycycle.bagleyd.abacus;

/*
 * @(#)AbacusStack.java
 *
 * Copyright 2020  David A. Bagley, bagleyd AT verizon.net
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

import java.util.Deque;
import java.util.LinkedList;

/**
 * The <code>Abacus</code> class allows one to undo and redo
 * in the <code>AbacusFrame</code>.
 *
 * @author	David A. Bagley
 * @author	bagleyd AT verizon.net
 * @author	https://www.sillycycle.com/puzzles.html
 */

class AbacusStack {
	private int aux, deck, rail, number;
	private int count;
	private final Deque<String> stack = new LinkedList<>();

	private void writeMoveAux(int aux) {
		this.aux = aux;
	}

	private void writeMoveDeck(int deck) {
		this.deck = deck;
	}

	private void writeMoveRail(int rail) {
		this.rail = rail;
	}

	private void writeMoveNumber(int number) {
		this.number = number;
	}

	int readMoveAux() {
		return this.aux;
	}

	int readMoveDeck() {
		return this.deck;
	}

	int readMoveRail() {
		return this.rail;
	}

	int readMoveNumber() {
		return this.number;
	}

	void setMove(int aux, int deck, int rail, int number) {
		writeMoveAux(aux);
		writeMoveDeck(deck);
		writeMoveRail(rail);
		writeMoveNumber(number);
		stack.push(Integer.toString(aux));
		stack.push(Integer.toString(deck));
		stack.push(Integer.toString(rail));
		stack.push(Integer.toString(number));
		count++;
	}

	void getMove() {
		number = Integer.parseInt(stack.pop());
		rail = Integer.parseInt(stack.pop());
		deck = Integer.parseInt(stack.pop());
		aux = Integer.parseInt(stack.pop());
		count--;
	}

	boolean madeMoves() {
		return !stack.isEmpty();
	}

	void flushMoves() {
		while (madeMoves())
			getMove();
		count = 0; // probably do not need
	}

	int numMoves() {
		return count;
	}
}
